#!/bin/sh
#\
exec wish "$0" "$@"

############## Variables ###################

proc set_tcgui {ix lst} {
	global tcgui
	foreach {name val} $lst {
		set tcgui($ix,$name) $val
	}
}

set_tcgui cmds { DISPLAY 1 WITHDRAW 2 SET-ATTR 3 INSERT-VALUE 4 
	SELECT-VALUE 5 WAIT 6 FOCUS 7 FOCUS-WAIT 8 SET-WINDOW-TITLE 9}
set_tcgui events { READY 0 ERROR 1 CLOSE 2 FOCUS 3}
set_tcgui attrs { FOREGROUND 1 BACKGROUND 2 FONT 3 RELIEF 4 BORDER 5 
	UNDERLINE 6 JUSTIFY 7 HIGHLIGHTTHICKNESS 8 INDICATORON 9 STATE 10 }

# Widget classes: Label Entry Group Image ComboBox 
# Listbox Button Checkbutton Radiobutton Text Timer

set_tcgui propdlg { Label lab Entry e Group gr Image i ComboBox cmb 
	Listbox l Button b Menubutton mb Checkbutton cb Radiobutton rb Text msg 
	Menuitem mi Timer t }
set_tcgui ccmd { Label cLabel Entry cEntry Group cGroup Image cImage
	ComboBox cCombo Listbox cList Button cButton 
	Menubutton cMenubutton Checkbutton cCheck
	Radiobutton cRadio Text cText Timer cTimer }
set tcgui(tcl_attribs) {foreground background font relief border underline
	justify highlightthickness indicatoron state}
set_tcgui attrib { 
	Label { widgetname label foreground background font relief border justify}
	Entry { widgetname cobolvar cobsize foreground background font 
		relief border justify highlightthickness}
	Group { widgetname label foreground background font relief border }
	Image { widgetname cobolvar cobsize background relief border}
	ComboBox { widgetname cobolvar cobsize foreground background font 
		relief border justify highlightthickness }
	Listbox { widgetname cobolvar cobsize foreground background font 
		relief border justify highlightthickness}
	Button { widgetname label eventname foreground background font 
		relief border state highlightthickness underline}
	Menuitem { widgetname label underline eventname cascade separator}
	Menubutton { widgetname label underline foreground background 
		font relief border indicatoron state}
	Checkbutton { widgetname label cobolvar cobsize  
		foreground background font relief border state highlightthickness}
	Radiobutton { widgetname selval label cobolvar foreground background 
		font relief border state highlightthickness}
	Text { widgetname cobolvar cobsize foreground background font 
		relief border}
	Timer { widgetname eventname count }
}

proc init_tcgui {} {
	global tcgui status
	set tcgui(defaults) { }
	set tcgui(autoname) 0
	set tcgui(snap) 5
	set tcgui(widgets) {}
	set tcgui(cutbuffer) ""
	set tcgui(container) .gui
	set status(container) gui 
	set tcgui(taborder) {}
	set tcgui(tabmarks) {}
	set tcgui(stay_cutting) 0
	set tcgui(posted_menus) {}
	set tcgui(curr_menu_item) {}
	set tcgui(menu_container) {}
}

set tcgui(name) "EXAMPLE"
set tcgui(initialfile) {untitled}

init_tcgui

set tcgui(default_message) "This is a multiline message displayed in several
lines."

image create photo idraw -data "\
R0lGODlhMAAwAPIFAAAAAAD/AP8AAP8A/////729vQAAAAAAACH5BAEAAAUALAAAAAAwADAA
AAP+WLrc/jAWIKu9gN4Ns9cTyI2h9oVkmjVnSq7L17oWXMo2La1yPOsin4dlCtJyP5/CeCzm
GDYmcBiBPXUFArUDkioE4HD4QdBSvKi0Q8weL8pIbgnSrguy5gez97Czy3lVRFcLfmGAGXcV
XWhfhnAAYjVLex6PZnU1SDiRdZB+GJwtnomGmidOjoagDmeuLXyrplCoolaqsm22r5xzBbkC
AcLDAbbFAMe2hX4DYcM4xdHPyMJ8DcwDzcEexN3TGdWEy23Z2cHe6NXhSdfk5dnU6cTg3xbu
7wPx8tLrG2L47/Sho5esUTuAAffF42aQgQCE+AROW1dtxEOICb1RI1hOjAMAjAAFguPYccNH
kBHncevWcAJKhBtJPjP5EuYxeQ1P1gy5r+SinRAlzju1q6jQmVgm9OzZcsdShUmVPk3XtMpU
qlGPTq3KxeiuCgkAADs="

image create photo iclock -data "\
R0lGODlhEAAQAPEDAL+/vwAAAP///8DAwCH5BAAAAAAALAAAAAAQABAAAAIyhI+pEN1rmpjz
pTBooCNcKmwaImpgeJTV6UWg9Kas2jJsOMpnnmZ7p4BpakEHEYJMKgoAOw=="

set comments(1) \
{************************************************************************
*
* Graphical User Interface generated by TCGUI
* 
* at date/time [clock format [clock seconds]] 
* from file $fn
*
************************************************************************}

############## Editor interface ##################
. config -menu .m
pack [frame .prop -width 450 -height 400] -expand 1 -fill both
pack [frame .status -bd 2 -relief sunken] -expand 1 -fill x
pack \
	[label .status.file_lb -text File:] \
	[label .status.file -relief groove -bd 2 -bg seashell \
	-width 20 -textvariable tcgui(initialfile) ] \
	[label .status.container_lb -text Container:] \
	[label .status.container -relief groove -bd 2 -bg seashell \
	-width 5 -textvariable status(container) ] \
	[label .status.operation_lb -text Op:] \
	[label .status.operation -relief groove -bd 2 -bg seashell \
	-width 10 -textvariable status(op) ] -side left -padx 3 -pady 3
toplevel .gui  -width 500 -height 400
wm title . "TCGUI editor"
wm title .gui "design window"
wm minsize . 300 250
wm minsize .gui 120 80

menu .m
.m add cascade -menu .m.file  -label File -underline 0
.m add cascade -menu .m.edit  -label Edit -underline 0
.m add cascade -menu .m.config  -label Config -underline 0
.m add cascade -menu .m.widgets  -label Widgets -underline 0
.m add cascade -menu .m.help  -label Help -underline 0

menu .m.file
.m.file add command -label New -accelerator Ctrl-n \
	-underline 0 -command file_new 
.m.file add command -label Save -accelerator Ctrl-s \
	-underline 0 -command file_save 
.m.file add command -label Open -accelerator Ctrl-o \
	-underline 0 -command file_load
.m.file add command -label Generate -accelerator Ctrl-g \
	-underline 0 -command generate_cpy 
.m.file add separator
.m.file add command -label exit -command exit -underline 1

menu .m.edit
.m.edit add command -label cut -accelerator Ctrl-x \
	-underline 1 -command bind_cut 
.m.edit add command -label "cut many" \
	-command {set tcgui(stay_cutting) 1; bind_cut}
.m.edit add command -label copy -accelerator Ctrl-c \
	-underline 0 -command bind_copy
.m.edit add command -label paste -accelerator Ctrl-v \
	-underline 0 -command paste_widget
.m.edit add command -label select -accelerator Escape \
	-underline 0 -command bind_select
.m.edit add command -label move -accelerator Ctrl-m \
	-underline 0 -command bind_move
.m.edit add command -label resize -accelerator Ctrl-r \
	-underline 0 -command bind_resize
.m.edit add separator
.m.edit add command -label "TAB order" -underline 4 -command bind_taborder 
.m.edit add command -label test -underline 0 -command bind_test

menu .m.config
.m.config add command -label "snap 1" -command {set_snap 1} 
.m.config add command -label "snap 2" -command {set_snap 2} 
.m.config add command -label "snap 5" -command {set_snap 5} 
.m.config add command -label "snap 10" -command {set_snap 10} 
.m.config add command -label "snap 20" -command {set_snap 20} 
.m.config add separator 
.m.config add command -label "Font..." -underline 0 -command set_font 

menu .m.widgets
.m.widgets add command -label "Label"    -command {add_widget cLabel}
.m.widgets add command -label "Entry"    -command {add_widget cEntry}   
.m.widgets add command -label "List"     -command {add_widget cList}
.m.widgets add command -label "Button"   -command {add_widget cButton}
.m.widgets add command -label "Menubutton"   -command {add_widget cMenubutton}
.m.widgets add command -label "Check"    -command {add_widget cCheck}
.m.widgets add command -label "Radio"    -command {add_widget cRadio}
.m.widgets add command -label "Group"    -command {add_widget cGroup}
.m.widgets add command -label "Text"  -command {add_widget cText}
.m.widgets add command -label "Combo"    -command {add_widget cCombo}
.m.widgets add command -label "Image"    -command {add_widget cImage}
.m.widgets add command -label "Timer"    -command {add_widget cTimer}

menu .m.help
.m.help add command -label About

update
#set xw [expr ([winfo screenwidth .]-[winfo width .gui])/2]
#set yw [expr ([winfo screenheight .]-[winfo height .gui])/2]
set xw [expr [winfo width .]+20]
set yw 20
wm geometry .gui +$xw+$yw
wm geometry . +10+20

set cw [winfo width .prop]
set ch [winfo height .prop]
frame .prop.screenbg -width $cw -height $ch -bg dodgerblue
#canvas .prop.screenbg -width $cw -height $ch -bg powderblue
#.prop.screenbg create rectangle 0 0 $cw $ch -fill dodgerblue \
#	-stipple @snap10.bm

place .prop.screenbg -relx 0.5 -rely 0.5 -anchor c
set tcgui(propdlg) [frame .prop.appl]
set w $tcgui(propdlg)
place $w -relx 0.5 -rely 0.5 -anchor c 
grid [label $w.lb1 -text "window name" -font {Helvetica 18 bold}] \
	[entry $w.e1 -textvariable tcgui(name) -font {Helvetica 18}] \
		-sticky nw -pady 2 -padx 4

proc have_attr {class attr} {
	global tcgui
	if {[lsearch $tcgui(attrib,$class) $attr] >= 0} {
		return 1
	} else {
		return 0
	}
}

proc aentry {args} {
	set e [uplevel entry $args]
	bindtags $e [concat apply [bindtags $e]]
	return $e
}

foreach {ix name} [array get tcgui propdlg,*] {
	set class [lindex [split $ix ,] 1]
	set w [frame .prop.$name]
	place $w -relx 0.5 -rely 0.5 -anchor c
	if {[have_attr $class widgetname]} {
		grid [label $w.lbname -text "widget name"] \
			[set tcgui(atentry,$class,widgetname) \
			[aentry $w.ename -width 20]] -sticky nw -pady 2 -padx 4
	}
	if {[have_attr $class selval]} {
		grid [label $w.lbsel -text "selected value"] \
			[set tcgui(atentry,$class,selval) \
			[aentry $w.esel -width 20]] -sticky nw -pady 2 -padx 4
	}
	if {[have_attr $class label]} {
		grid [label $w.lbl -text "label"] \
			[set tcgui(atentry,$class,label) \
			[aentry $w.el -width 20]] -sticky nw -pady 2 -padx 4
	}
	if {[have_attr $class cobolvar]} {
		grid [label $w.lb1 -text "cobol variable"] \
			[set tcgui(atentry,$class,cobolvar) \
			[aentry $w.e1 -width 32]] -sticky nw -pady 2 -padx 4
	}
	if {[have_attr $class cobsize]} {
		grid [label $w.lb2 -text "size (chars)"] \
			[set tcgui(atentry,$class,cobsize) \
			[aentry $w.e2 -width 4]] -sticky nw -pady 2 -padx 4
	}
	if {[have_attr $class eventname]} {
		grid [label $w.lb2 -text "event name"] \
			[set tcgui(atentry,$class,eventname) \
			[aentry $w.e2 -width 15]] -sticky nw -pady 2 -padx 4
	}
	if {[have_attr $class cascade]} {
		grid [label $w.lbcas -text "cascade menu"] \
			[set tcgui(atentry,$class,cascade) \
			[checkbutton $w.cbcas -command \
				{apply_attrib $tcgui(curr_widget) $tcgui(curr_menu_item)}
			]] \
			-sticky nw -pady 2 -padx 4
	}
	if {[have_attr $class separator]} {
		grid [label $w.lbsep -text "separator"] \
			[set tcgui(atentry,$class,separator) \
			[checkbutton $w.cbsep -command \
				{apply_attrib $tcgui(curr_widget) $tcgui(curr_menu_item)}
			]] \
			-sticky nw -pady 2 -padx 4
	}
	if {[have_attr $class underline]} {
			grid [label $w.lbu -text "underline"] \
				[set tcgui(atentry,$class,underline) \
				[aentry $w.eu -width 2]] \
				-sticky nw -pady 2 -padx 4
	}
	if {[have_attr $class state]} {
			grid [label $w.lbst -text "state"] \
				[set tcgui(atentry,$class,state) \
				[aentry $w.est -width 8]] \
				[button $w.bst -text " " \
					-command [list ch_state $w.bst $w.est]] \
				-sticky nw -pady 2 -padx 4
	}
	if {[have_attr $class indicatoron]} {
			grid [label $w.lbind -text "indicator"] \
				[set tcgui(atentry,$class,indicatoron) \
				[aentry $w.eind -width 1]] \
				-sticky nw -pady 2 -padx 4
	}
	if {[have_attr $class highlightthickness]} {
			grid [label $w.lbhighl -text "highlightthickness"] \
				[set tcgui(atentry,$class,highlightthickness) \
				[aentry $w.ehighl -width 2]] \
				-sticky nw -pady 2 -padx 4
	}
	if {[have_attr $class count]} {
			grid [label $w.lbcnt -text "count (1/10s)"] \
				[set tcgui(atentry,$class,count) \
				[aentry $w.ecnt -width 2]] \
				-sticky nw -pady 2 -padx 4
	}
	if {[have_attr $class justify]} {
			grid [label $w.lbjust -text "justify"] \
				[set tcgui(atentry,$class,justify) \
				[aentry $w.ejust -width 6]] \
				[button $w.bjust -text " " \
					-command [list ch_just $w.bjust $w.ejust]] \
				-sticky nw -pady 2 -padx 4
	}
	switch $class {
	Label -
	Entry -
	ComboBox -
	Listbox -
	Button -
	Menubutton -
	Checkbutton -
	Radiobutton -
	Text -
	Group {
			grid [label $w.lb5 -text "foreground"] \
				[set tcgui(atentry,$class,foreground) \
				[aentry $w.e5 -width 10]] \
				[button $w.b5 -text " " -command [list ch_color $w.b5 $w.e5]] \
				-sticky new -pady 2 -padx 4
			grid [label $w.lb6 -text "background"] \
				[set tcgui(atentry,$class,background) \
				[aentry $w.e6 -width 10]] \
				[button $w.b6 -text " " -command [list ch_color $w.b6 $w.e6]] \
				-sticky new -pady 2 -padx 4
			grid [label $w.lb7 -text "font"] \
				[set tcgui(atentry,$class,font) \
				[aentry $w.e7 -width 25]] \
				[button $w.b7 -text " " -command [list ch_font $w.b7 $w.e7]] \
				-sticky nw -pady 2 -padx 4
			grid [label $w.lb8 -text "relief"] \
				[set tcgui(atentry,$class,relief) \
				[aentry $w.e8 -width 10]] \
				[button $w.b8 -text " " -command [list ch_relief $w.b8 $w.e8]] \
				-sticky nw -pady 2 -padx 4
			grid [label $w.lb9 -text "border"] \
				[set tcgui(atentry,$class,border) \
				[aentry $w.e9 -width 2]] -sticky nw -pady 2 -padx 4
		}
	Image {
			grid [label $w.lb6 -text "background"] \
				[set tcgui(atentry,$class,background) \
				[aentry $w.e6 -width 10]] \
				[button $w.b6 -text " " -command [list ch_color $w.b6 $w.e6]] \
				-sticky new -pady 2 -padx 4
			grid [label $w.lb8 -text "relief"] \
				[set tcgui(atentry,$class,relief) \
				[aentry $w.e8 -width 10]] -sticky nw -pady 2 -padx 4
			grid [label $w.lb9 -text "border"] \
				[set tcgui(atentry,$class,border) \
				[aentry $w.e9 -width 10]] -sticky nw -pady 2 -padx 4
		}
	}
}

raise .prop.screenbg
raise .prop.appl

################## USER WIDGETS #####################

proc cWidget { type name parent x y wd ht var size offset args } {
	global tcgui
	#puts "cWidget: type: $type name: $name parent: $parent"
	if {$parent == "."} {
		set parent ".gui"
	} else {
		set parent .gui$parent
	}
	#set w [frame [join [list $parent $name] .]]
	if {$type == "cMenuitem"} {
		set w $parent.m
	} else {
		set w [frame $parent.$name]
		if {$wd} {
			$w config -width $wd
		}
		if {$ht} {
			$w config -height $ht
		}
	}
	set dtxt "     "
	switch $type {
	cLabel { 
			set ww [label $w.w -text Label]
			set tcgui(container,$w.w) $w
		}
	cEntry {
			set ww [entry $w.w -width 15]
			set tcgui(container,$w.w) $w
			lappend tcgui(taborder) $w.w
		}
	cList {
			scrollbar $w.sv -orient vertical -width 8 \
				-border 1 -command [list $w.w yview]
			scrollbar $w.sh -orient horizontal -width 8 \
				-border 1 -command [list $w.w xview]
			set ww [listbox $w.w -font {courier 12} -width 15 -height 4 \
				-yscrollcommand [list $w.sv set] \
				-xscrollcommand [list $w.sh set] -takefocus 1]
			pack $w.sh -side bottom -fill x
			pack $w.sv -side right -fill y
			set tcgui(container,$w.w) $w
			lappend tcgui(taborder) $w.w
		}
	cMenubutton {
			set ww [menubutton $w.w -text "Menu  " -underline 0 \
				-menu $w.w.m -relief flat]
			bindtags $w.w [list edit $w.w] 
			set tcgui(container,$w.w.m) $w.w
			menu $w.w.m -tearoff 0
			#set tcgui(parent,$w.w.m) $w.w
			bindtags $w.w.m edit 
			$w.w.m add command -label "<empty>" 
			#$w.w.m add cascade -label "<empty menu>" \
			#	-menu $w.w.m.empty 	
			#menu $w.w.m.empty -tearoff 0
			#bindtags $w.w.m.empty [list edit [bindtags $w.w.m.empty]]
			#$w.w.m.empty add command -label "<empty>" 
			set tcgui(container,$w.w.m.empty) $w.w.m
			set tcgui(container,$w.w) $w
		}
	cMenuitem {
			set ww {}
			if {[winfo class $parent] == "Menu"} {
				set m $parent
			} else {
				set m $parent.m
			}
			set mi [$m index end]
			array set wargs $args
			if {[info exists wargs(cascade)] &&
				$wargs(cascade) == 1} {
					$m insert $mi cascade -menu $m.$mi
					menu $m.$mi -tearoff 0
					set tcgui(container,$m.$mi) $m
					bindtags $m.$mi edit 
					$m.$mi add command -label "<empty>"
			} elseif {[info exists wargs(separator)] &&
				$wargs(separator) == 1} {
					$m insert $mi separator
			} else {
				$m insert $mi command
			}
		}
	cButton {
			set ww [button $w.w -text button]
			set tcgui(container,$w.w) $w
			lappend tcgui(taborder) $w.w
		}
	cCheck {
			set ww [checkbutton $w.w -text check ]
			set tcgui(container,$w.w) $w
			lappend tcgui(taborder) $w.w
		}
	cRadio {
			set ww [radiobutton $w.w -text radio ]
			set tcgui(container,$w.w) $w
			lappend tcgui(taborder) $w.w
		}
	cGroup {
			set ww [frame $w.w -class Group]
			pack [frame $w.w.fr -bd 2 -relief groove -width 100 -height 100] \
				-pady 10 -expand 1 -fill both
			place [label $w.w.lab] \
					-in $w.w.fr -x 7 -y 0 -anchor w
			bindtags $w.w.fr [concat edit [bindtags $w.w.fr]]
			set tcgui(container,$w.w.fr) $w
			set tcgui(container,$w.w) $tcgui(container) 
			set_container $w
		}
	cText { 
			set ww [text $w.w -width 15 -height 4]
			set tcgui(container,$w.w) $w
		}
	cCombo { 
			set ww [combobox $w.w -width 15]
			set tcgui(container,$w.w.e) $w
			set tcgui(container,$w.w.b) $w
			bindtags $w.w.e [concat edit [bindtags $w.w.e]]
			bindtags $w.w.b [concat edit [bindtags $w.w.b]]
			lappend tcgui(taborder) $w.w.e
		}
	cImage { 
			set ww [frame $w.w -class Image]
			pack [label $w.w.i -image idraw -bg white] -expand 1 -fill both
			set tcgui(container,$w.w.i) $w
			bindtags $w.w.i [concat edit [bindtags $w.w.i]]
		}
	cTimer { 
			set ww [frame $w.w -bd 2 -relief raised -class Timer]
			pack [label $w.w.t -image iclock] -expand 1 -fill both
			set tcgui(container,$w.w.t) $w
			bindtags $w.w.t [concat edit [bindtags $w.w.t]]
		}
	}
	if {$ww == {}} {
		# menu items are not packed
		eval set_menu_attribs $m $mi $args
		return
	}
	pack $ww -expand 1 -fill both
	place $w -x $x -y $y
	update
	set wid [winfo width $w]
	set hei [winfo height $w]
	pack propagate $w 0
	$w config -height $hei -width $wid
	bindtags $w.w [concat edit [bindtags $w.w]]
	lappend tcgui(widgets) $w
	#set tcgui(parent,$w) $parent
	set tcgui(parent,$w) .[string trimleft $parent ".gui"]
	if {$wd} {
		$w config -width $wd
	}
	if {$ht} {
		$w config -height $ht
	}
	
	eval set_attribs $w.w $args
	set tcgui(value,$w.w,cobolvar) $var
	set tcgui(value,$w.w,cobsize) $size
	set tcgui(coboffset,$w.w) $offset
	return $w	
}

proc cLabel {args} { 	eval cWidget cLabel $args }
proc cEntry {args} { 	eval cWidget cEntry $args }
proc cList {args} { 	eval cWidget cList $args }
proc cButton {args} { 	eval cWidget cButton $args }
proc cMenubutton {args} { 	eval cWidget cMenubutton $args }
proc cMenuitem {args} { 	eval cWidget cMenuitem $args }
proc cCheck {args} { 	eval cWidget cCheck $args }
proc cRadio {args} { 	eval cWidget cRadio $args }
proc cGroup {args} { 	eval cWidget cGroup $args }
proc cText {args} { 	eval cWidget cText $args }
proc cCombo {args} { 	eval cWidget cCombo $args }
proc cImage {args} { 	eval cWidget cImage $args }
proc cTimer {args} { 	eval cWidget cTimer $args }

################ WIDGET PROPERTIES DIALOGS ################
proc apply_attrib {w {mitem {}}} {
	global tcgui
	set class [winfo class $w]
	if {[info exists tcgui(value,$w,widgetname)] &&
		$tcgui(value,$w,widgetname) != ""} {
		 set cname $tcgui(value,$w,widgetname)
	} else {
		set cname [lindex [split $w .] end-1]
	}
	set tcgui(value,$w,widgetname) $cname
	if {$class == "Group"} {
		foreach at $tcgui(attrib,$class) {
			if {[info exists tcgui(value,$w,$at)] &&
				$tcgui(value,$w,$at) != "" &&
				[lsearch $tcgui(tcl_attribs) $at]>=0} {
					$w.fr config -$at $tcgui(value,$w,$at)
					if {[lsearch {border relief} $at]<0} {
						$w.lab config -$at $tcgui(value,$w,$at)
					}
			} elseif {$at == "label"} {
				if {[info exists tcgui(value,$w,label)] &&
					$tcgui(value,$w,label) != ""} {
						$w.lab config -text $tcgui(value,$w,$at)
						place $w.lab -in $w.fr -x 7 -y 0 -anchor w
						pack $w.fr -pady 10
				} else {
					place forget $w.lab
					pack $w.fr -pady 0
				}
			}
		}	
	} elseif {$class == "ComboBox"} {
		foreach at $tcgui(attrib,$class) {
			# standard tcl attributes
			if {[info exists tcgui(value,$w,$at)] &&
				$tcgui(value,$w,$at) != "" &&
				[lsearch $tcgui(tcl_attribs) $at]>=0} {
					$w.e config -$at $tcgui(value,$w,$at)
			} elseif {$at == "label" &&
				[info exists tcgui(value,$w,label)]} {
			# special label attribute for buttons, groups and labels
				$w.e config -text $tcgui(value,$w,$at)
			} 
		}
	} elseif {$class == "Menu"} {
		#puts -nonewline "apply_attrib: Menu $w $mitem \{"
		foreach at $tcgui(attrib,Menuitem) {
			#if {[info exists tcgui(value,$w,$mitem,$at)]} {
			#	puts "\t$at --> $tcgui(value,$w,$mitem,$at)"
			#} else {
			#	puts "\t $at --> (null)"
			#}
			# standard tcl attributes
			
			# if we have changed this entry into a cascade
			if {[info exists tcgui(value,$w,$mitem,cascade)] &&
				$tcgui(value,$w,$mitem,cascade) == 1 &&
				[$w type $mitem] != "cascade"} {
					$w delete $mitem 
					$w insert $mitem cascade -menu $w.$mitem
					destroy $w.$mitem
					menu $w.$mitem -tearoff 0
					set tcgui(container,$w.$mitem) $w
					bindtags $w.$mitem edit 
					$w.$mitem add command -label "<empty>"
			}
			# if changed from a cascade back
			if {[info exists tcgui(value,$w,$mitem,cascade)] &&
				$tcgui(value,$w,$mitem,cascade) == 0 &&
				[$w type $mitem] == "cascade"} {
					$w delete $mitem 
					$w insert $mitem command
					destroy $w.$mitem
			}
			# if changed to a separator
			if {[info exists tcgui(value,$w,$mitem,separator)] &&
				$tcgui(value,$w,$mitem,separator) == 1 &&
				[$w type $mitem] != "separator"} {
					$w delete $mitem 
					$w insert $mitem separator
			}
			# if changed from a separator back
			if {[info exists tcgui(value,$w,$mitem,separator)] &&
				$tcgui(value,$w,$mitem,separator) == 0 &&
				[$w type $mitem] == "separator"} {
					$w delete $mitem 
					$w insert $mitem command
			}
			if {[info exists tcgui(value,$w,$mitem,$at)] &&
				$tcgui(value,$w,$mitem,$at) != "" &&
				[lsearch $tcgui(tcl_attribs) $at]>=0 &&
				[$w type $mitem] != "separator"} {
					$w entryconfig $mitem -$at $tcgui(value,$w,$mitem,$at)
			} elseif {$at == "label" &&
				[info exists tcgui(value,$w,$mitem,label)] &&
				[$w type $mitem] != "separator"} {
					$w entryconfig $mitem -label $tcgui(value,$w,$mitem,$at)
			}
			# if we are editing the last item, append a new fresh <empty> 
			if {[$w index end] == $mitem} {
				$w add command -label "<empty>" 
			}
		}
		#puts "\}"
	} else {
		foreach at $tcgui(attrib,$class) {
			# standard tcl attributes
			if {[info exists tcgui(value,$w,$at)] &&
				$tcgui(value,$w,$at) != "" &&
				[lsearch $tcgui(tcl_attribs) $at]>=0} {
					$w config -$at $tcgui(value,$w,$at)
			} elseif {$at == "label" &&
				[info exists tcgui(value,$w,label)]} {
			# special label attribute for buttons, groups and labels
				$w config -text $tcgui(value,$w,$at)
			}
		}
	}
}

proc set_menu_attribs {m mi args} {
	global tcgui
	#puts "set_menu_attribs: $m $mi -> $args"
	foreach {at val} $args {
		set	tcgui(value,$m,$mi,$at) $val
	}
	apply_attrib $m $mi
}

proc set_attribs {w args} {
	global tcgui
	#puts "set_attribs: $w -> $args"
	foreach {at val} $args {
		set	tcgui(value,$w,$at) $val
	}
	apply_attrib $w
}

proc reconnect_prop_entries {w} {
	global tcgui
	set class [winfo class $w]
	foreach at $tcgui(attrib,$class) {
		$tcgui(atentry,$class,$at) config -textvariable "" 
		$tcgui(atentry,$class,$at) delete 0 end
	}
	foreach at $tcgui(attrib,$class) {
		catch {	$tcgui(atentry,$class,$at) config \
					-textvariable tcgui(value,$w,$at)}
	}
	set tcgui(curr_widget) $w
}

proc show_menu_prop {w item} {
	global tcgui
	#puts "show_menu_prop: $w $item"
	set tcgui(propdlg) .prop.mi
	raise .prop.screenbg
	set class Menuitem
	foreach at $tcgui(attrib,$class) {
		set cw $tcgui(atentry,$class,$at)
		$cw config -textvariable "" 
		if {[winfo class $cw] == "Entry"} {
			$cw delete 0 end
		} else {
			# checkbutton for menu items
		}
	}
	foreach at $tcgui(attrib,$class) {
		if {$at == "cascade" || $at == "separator"} {
			catch {	$tcgui(atentry,$class,$at) config \
					-variable tcgui(value,$w,$item,$at)}
		} else {
			$tcgui(atentry,$class,$at) config \
				-textvariable tcgui(value,$w,$item,$at)
		}
	}
	set tcgui(curr_widget) $w
	set tcgui(curr_menu_item) $item 
	raise $tcgui(propdlg) 
}

proc show_propdlg {w} {
	global tcgui
	set w $w.w
	set class [winfo class $w]
	set tcgui(propdlg) .prop.$tcgui(propdlg,$class)
	raise .prop.screenbg
# setup widget instance variables
	reconnect_prop_entries $w	
	raise $tcgui(propdlg) 
}

################# WIDGET MANIPULATION COMMANDS #####################

proc ch_font {b e} {
	global tcgui
	set oldfont [string trim [$e get]]
	if {$oldfont != ""} {
		set newfont [chooseFont -initialfont $oldfont]
	} else {
		set newfont [chooseFont]
	}
	$e delete 0 end
	$e insert end $newfont
	apply_attrib $tcgui(curr_widget)
}

proc ch_just {b e} {
	global tcgui newjust
	toplevel .just
	wm transient .just .
	wm geometry .just +[winfo pointerx .just]+[winfo pointery .just]
	set lb [listbox .just.lb -width 7 -height 3]
	pack $lb
	$lb insert end left center right
	update
	grab -global .just
	bind $lb <1> {set newjust 1}
	tkwait variable newjust 
	grab release .just
	set newjust [$lb get [$lb curselection]]
	$e delete 0 end
	$e insert end $newjust
	apply_attrib $tcgui(curr_widget)
	destroy .just
}

proc ch_state {b e} {
	global tcgui newstate
	toplevel .state
	wm transient .state .
	wm geometry .state +[winfo pointerx .state]+[winfo pointery .state]
	set lb [listbox .state.lb -width 8 -height 3]
	pack $lb
	$lb insert end normal active disabled
	update
	grab -global .state
	bind $lb <1> {set newstate 1}
	tkwait variable newstate
	grab release .state
	set newstate [$lb get [$lb curselection]]
	$e delete 0 end
	$e insert end $newstate
	apply_attrib $tcgui(curr_widget)
	destroy .state
}

proc ch_relief {b e} {
	global tcgui newrelief
	toplevel .relief
	wm transient .relief .
	wm geometry .relief +[winfo pointerx .relief]+[winfo pointery .relief]
	set lb [listbox .relief.lb -width 7 -height 6]
	pack $lb
	$lb insert end flat raised sunken ridge groove solid
	update
	grab -global .relief 
	bind $lb <1> {set newrelief 1}
	tkwait variable newrelief 
	grab release .relief
	set newrelief [$lb get [$lb curselection]]
	$e delete 0 end
	$e insert end $newrelief
	$b configure -relief $newrelief
	apply_attrib $tcgui(curr_widget)
	destroy .relief
}

proc ch_color {b e} {
	global tcgui
	set oldcolor [string trim [$e get]]
	if {$oldcolor != ""} {
		set newcolor [tk_chooseColor -initialcolor $oldcolor]
	} else {
		set newcolor [tk_chooseColor]
	}
	$e delete 0 end
	$e insert end $newcolor
	$b configure -bg $newcolor
	apply_attrib $tcgui(curr_widget)
}

proc list_delete {list_name item} {
	upvar $list_name lst
	set i [lsearch $lst $item]
	if {$i < 0} {
		return
	}
	set lst [lreplace $lst $i $i]
}

proc set_container {c} {
	global tcgui
	#$tcgui(container) config -bg gray80
	if {$c == ".gui"} {
		set tcgui(container) .gui
		set tcgui(propdlg) .prop.appl
		raise .prop.screenbg
		raise $tcgui(propdlg) 
	} else {
		set tcgui(container) $c.w.fr
	}
	#$tcgui(container) config -bg gray90
	global status
	set status(container) [lindex [split $c .] end]
}

proc set_font {} {
	global tcgui
	if {[info exists tcgui(curr_widget)]} {
		set w $tcgui(curr_widget)
		set	tcgui(value,$w,font) [chooseFont]
	}
}

proc set_snap {n} {
	global tcgui 
	set tcgui(snap) $n
}

proc snap { xl yl } {
	global tcgui 
	upvar $xl x
	upvar $yl y
	set x [expr $x - ($x % $tcgui(snap))]
	set y [expr $y - ($y % $tcgui(snap))]
}

proc autoname {} {
	global tcgui
	return [format %03d [incr tcgui(autoname)]]
}

proc add_widget {wd} {
	global tcgui 
	set wname [autoname]
	if {$wd == "cMenuitem"} {
		set parent $tcgui(menu_container)
		bind_select
	} else {
		set parent .[string trimleft $tcgui(container) ".gui"]
		bind_move
	}
	set w [$wd $wname $parent 0 0 0 0 "" 1 0]
}

proc paste_menuitem {} {
	global tcgui
	set m $tcgui(menu_container)
	set parent .[join [lrange [split $m .] 2 end] .]
	set cb $tcgui(cutbuffer)
	set cb [lreplace $cb 2 2 $parent]
	uplevel #0 $cb
}

proc paste_widget {} {
	global tcgui
	if {$tcgui(cutbuffer) != ""} {
		if {[lindex $tcgui(cutbuffer) 0] == "cMenuitem"} {
			paste_menuitem
			return
		}
		set cb $tcgui(cutbuffer)
		set cb [lreplace $cb 1 1 [autoname]]
		set xnew [expr [lindex $cb 3] + 15] 
		set ynew [expr [lindex $cb 4] + 10] 
		set c $tcgui(container)
		set parent .[join [lrange [split $c .] 2 end] .]
		set cb [lreplace $cb 2 2 $parent]
		set cw [winfo width $c]
		set ch [winfo height $c]
		set ow [lindex $cb 5]
		set oh [lindex $cb 6]
		if {($xnew+$ow) > $cw} {
			set xnew 0
		}
		if {($ynew+$oh) > $ch} {
			set ynew 0
		}
		set cb [lreplace $cb 3 4 $xnew $ynew] 
		uplevel #0 $cb
		set tcgui(cutbuffer) $cb
	}
	bind_move
}

proc copy_widget {w x y} {
	global tcgui
	set w $tcgui(container,$w)
	set tcgui(cutbuffer) [widget_desc $w]
	bind_select
	return -code break
}

proc cut_menu_item {m y} {
	global tcgui
	set y [expr $y-[winfo y $m]]
	set mi [$m index @$y]
	set mend [$m index end]
	if {$mi == $mend} {
		return
	}
	set tcgui(cutbuffer) [menu_desc $m $mi ??]
	set tcgui(menu_container) $m
	if {[$m type $mi] == "cascade"} {
		foreach jx [array names tcgui *,$m.$mi,*] {
			unset tcgui($jx)
		}
	}
	foreach ix [array names tcgui *,$m,$mi,*] {
		unset tcgui($ix)
	}
	# move all menuitems below this up
	for {set i $mi} {$i < [$m index end]} {incr i} {
		if {[$m type $i] == "cascade"} {
			foreach jx [array names tcgui *,$m.$i,*] {
				unset tcgui($jx)
			}
		}
		foreach ix [array names tcgui *,$m,$i,*] {
			set ixlist [split $ix ,]
			set ixlist [lreplace $ixlist 2 2 [expr $i-1]]
			set newix [join $ixlist ,]
			set tcgui($newix) $tcgui($ix)
		}
	}
	$m delete $mi
	bind_select
}

proc cut_widget {w x y} {
	global tcgui
	if {[winfo class $w] == "Menu"} {
		cut_menu_item $w $y
		return
	}
	if {$w == $tcgui(container)} {
		set tcgui(container) .gui
	}
	set w $tcgui(container,$w)
	set tcgui(cutbuffer) [widget_desc $w]
	set class [winfo class $w]
	# if we are destroying a group, change default container
#	if {$class == "Group"} {
#		set tcgui(container) .gui
#	}
	list_delete tcgui(widgets) $w
	set n [lsearch -glob $tcgui(taborder) $w*]
	if {$n >= 0} {
		set tcgui(taborder) [lreplace $tcgui(taborder) $n $n]
	}
	destroy $w
	if {!$tcgui(stay_cutting)} {
		bind_select
	}
	return -code break
}

proc start_move_menuitem {w y} {
	global tcgui ixs
	set y [expr $y - [winfo rooty $w]]
	set ixs [$w index @$y]
	$w activate $ixs
}

proc end_move_menuitem {m y} {
	global tcgui ixs
	if {[winfo class $m] == "Menu"} {
		set y [expr $y - [winfo rooty $m]]
		set ixe [$m index @$y]
		if {[$m index end] == $ixe} {
			incr ixe -1
		}
		$m activate none
		# rotate all menuitems between the start and end
		array set tmp [array get tcgui *,$m,$ixs,*]
		if {$ixe > $ixs} {
			for {set i [expr $ixs+1]} {$i <= $ixe} {incr i} {
				foreach ix [array names tcgui *,$m,$i,*] {
					set ixlist [split $ix ,]
					set ixlist [lreplace $ixlist 2 2 [expr $i-1]]
					set newix [join $ixlist ,]
					set tcgui($newix) $tcgui($ix)
					if {[$m type $i] == "cascade"} {
						foreach jx [array names tcgui *,$m.$i,*] {
							unset tcgui($jx)
						}
					}
				}
			}
		} else {
			for {set i [expr $ixs-1]} {$i >= $ixe} {incr i -1} {
				foreach ix [array names tcgui *,$m,$i,*] {
					set ixlist [split $ix ,]
					set ixlist [lreplace $ixlist 2 2 [expr $i+1]]
					set newix [join $ixlist ,]
					set tcgui($newix) $tcgui($ix)
					if {[$m type $i] == "cascade"} {
						foreach jx [array names tcgui *,$m.$i,*] {
							unset tcgui($jx)
						}
					}
				}
			}
		}
		# put moved item 
		foreach ix [array names tmp] {
			set ixlist [split $ix ,]
			set ixlist [lreplace $ixlist 2 2 $ixe]
			set newix [join $ixlist ,]
			set tcgui($newix) $tmp($ix)
		}
		for {set i $ixs} {$i <= $ixe} {incr i} {
			apply_attrib $m $i
		}
	}
}

proc start_move_widget {w x y} {
	global tcgui xs ys xx yy
	#set tcgui(selected) $w
	if {[winfo class $w] == "Menu"} {
		start_move_menuitem $w $y
		return
	}
	snap x y
	set w $tcgui(container,$w)
	set xs $x
    set ys $y
	array set tmp [place info $w]
	set xx $tmp(-x)
	set yy $tmp(-y)
	#show_propdlg $w
	return -code break
}

proc move_widget {w x y} {
	global tcgui ixs dx dy xs ys xx yy
	if {[winfo class $w] == "Menu"} {
		set y [expr $y - [winfo rooty $w]]
		$w activate [$w index @$y]
		return
	}
	snap x y
	set w $tcgui(container,$w)
	set p $tcgui(parent,$w)
	if {$p == "."} {
		set p .gui
	} else {
		set p .gui$p
	}
	set dx [expr $x - $xs]
    set dy [expr $y - $ys]
	set xx [expr $xx + $dx]
    set yy [expr $yy + $dy]
    if {$xx < 0} {
		set xx 0
	}
    if {$yy < 0} {
		set yy 0
	}
	set pw [winfo width $p]
	set ph [winfo height $p]
	set ow [winfo width $w]
	set oh [winfo height $w]
	if {($xx+$ow) > $pw} {
		set xx [expr $pw-$ow]
	}
	if {($yy+$oh) > $ph} {
		set yy [expr $ph-$oh]
	}
	place $w -x $xx -y $yy 
    set xs $x
    set ys $y
	return -code break
}

proc start_resize_widget {w x y} {
	global tcgui xs ys xx yy
	snap x y
	set w $tcgui(container,$w)
	set xs $x
    set ys $y
    set xx [winfo width $w]
    set yy [winfo height $w]
	return -code break
}

proc resize_widget {w x y} {
	global tcgui dx dy xs ys xx yy
	snap x y
	set w $tcgui(container,$w)
	set p $tcgui(parent,$w)
	if {$p == "."} {
		set p .gui
	} else {
		set p .gui$p
	}
    set dx [expr $x - $xs]
    set dy [expr $y - $ys]
	set xx [expr $xx + $dx]
    set yy [expr $yy + $dy]
	if {$xx < 20} {
		set xx 20
	}
	if {$yy < 20} {
		set yy 20
	}
	set pw [winfo width $p]
	set ph [winfo height $p]
	set ox [winfo x $w]
	set oy [winfo y $w]
	if {$ox+$xx > $pw} {
		set xx [expr $pw-$ox]
	}
	if {$oy+$yy > $ph} {
		set yy [expr $ph-$oy]
	}
	$w config -width $xx -height $yy
    set xs $x
    set ys $y
	return -code break
}

################## BINDINGS ######################

bind .gui <3> {tk_popup .m.edit %X %Y}
bind .gui <2> {tk_popup .m.widgets %X %Y}
bind .gui <Shift-3> {tk_popup .m.widgets %X %Y}
bind edit <Tab> {next_taborder %W ; break}

bind all <Delete> bind_cut
bind all <Control-x> bind_cut
bind all <Control-c> bind_copy
bind all <Insert> paste_widget
bind all <Control-v> paste_widget
bind all <Control-r> bind_resize
bind all <Control-m> bind_move
bind all <Escape> bind_select
bind all <Control-n> file_new
bind all <Control-s> file_save
bind all <Control-o> file_load
bind all <Control-g> generate_cpy
bind all <Alt-x> exit  


bind apply <Return> {
	apply_attrib $tcgui(curr_widget) $tcgui(curr_menu_item)
	focus [tk_focusNext %W]
	break
}

bind apply <Tab> {
	apply_attrib $tcgui(curr_widget) $tcgui(curr_menu_item)
	focus [tk_focusNext %W]
	break
}

proc set_cursor {cursor} {
	bind edit <Enter> {}
	bind edit <Enter> "%W config -cursor $cursor"
	set x [winfo pointerx .gui]
	set y [winfo pointery .gui]
	set w [winfo containing $x $y]
	if {$w != ""} {
		event generate $w <Leave>
		event generate $w <Enter>
	}
}

proc draw_tab_marks {} {
	global tcgui
	set n 0
	set tcgui(tabmarks) {}
	foreach w $tcgui(taborder) {
		incr n
		set t .gui.mark#$n 
		lappend tcgui(tabmarks) \
			[label $t -text $n -bg black -fg white]
		array set wi [place info $tcgui(container,$w)]
		set in [join [lrange [split $tcgui(container,$w) .] 0 end-1] .]
		place $t -in $in -x $wi(-x) -y $wi(-y) -anchor c 
	}
}

proc clear_tab_marks {} {
	global tcgui
	foreach w $tcgui(tabmarks) {
		destroy $w
	}
}

proc no_cut {} {
	global tcgui
	set tcgui(stay_cutting) 0
}

proc bind_show_propdlg {} {
	bind .gui <Double-1> {
		set_container .gui 
	}
	bind edit <Double-1> { 
		set w $tcgui(container,%W)
	    if {[winfo class %W] == "Menu"} {
			#set ix [%W index @%x,%y]
			#%W postcascade $ix
			break
		} else {
			if {[winfo class $w.w] == "Group"} {
				set_container $w
			}
			show_propdlg $w
			break
		}
	}
}

proc bind_test {} {
	clear_tab_marks
	set_cursor left_ptr
	bind edit <1> "" 
	bind edit <B1-Motion> ""
	bind edit <Double-1> ""
	bind edit <3> {}
	bind .gui <Double-1> ""
	bind .gui <1> ""
	global status
	set status(op) TEST
	no_cut
}

proc unpost_all {} {
	global tcgui
	foreach w $tcgui(posted_menus) {
		catch { $w unpost }
	}
	set tcgui(posted_menus) {}
}

proc bind_select {} {
	global tcgui
	clear_tab_marks
	set_cursor center_ptr 
	bind edit <1> { 
		global tcgui
		set w $tcgui(container,%W)
		#puts "edit <1> $w [winfo class $w]  %W [winfo class %W]"
		if {[winfo class %W] == "Menu"} {
			#puts "Menu: %W %x %y active: [%W index @%x,%y]"
			set tcgui(menu_container) %W
			show_menu_prop %W [%W index @%x,%y]
			set ix [%W index @%x,%y]
			if {[%W type $ix] == "cascade"} {
				%W postcascade $ix
				lappend tcgui(posted_menus) [%W entrycget $ix -menu]
			} 
		} else {
			unpost_all
			set class [winfo class $w.w]
			if {$class == "Group"} {
				set_container $w
			}
			show_propdlg $w
			if {$class != "Menubutton"} {
				break
			} else {
				#puts "Menubutton: %W %X %Y"
				set x [winfo rootx %W]
				set y [expr [winfo rooty %W]+[winfo height %W]]
				$w.w.m post $x $y 
				lappend tcgui(posted_menus) $w.w.m
			}
		}
	}
	bind .gui <1> {
		set_container .gui 
		unpost_all
	}
	bind edit <B1-Motion> {}
	bind edit <ButtonRelease-1> {}
	bind edit <3> {}
	bind_show_propdlg
	global status
	set status(op) select
	no_cut
}

proc bind_move {} {
	clear_tab_marks
	set_cursor fleur 
	bind edit <1> { start_move_widget %W %X %Y }
	bind edit <ButtonRelease-1> { end_move_menuitem %W %Y }
	bind edit <B1-Motion> { move_widget %W %X %Y }
	bind edit <3> {}
	bind .gui <1> ""
	bind_show_propdlg
	global status
	set status(op) move 
	no_cut
}

proc bind_resize {} {
	clear_tab_marks
	set_cursor sizing 
	bind edit <1> { start_resize_widget %W %X %Y }
	bind edit <B1-Motion> { resize_widget %W %X %Y }
	bind edit <ButtonRelease-1> {}
	bind edit <3> {}
	bind .gui <1> ""
	bind_show_propdlg
	global status
	set status(op) resize
	no_cut
}

proc bind_taborder {} {
	draw_tab_marks
	set_cursor hand1 
	bind edit <1> { change_taborder %W end }
	bind edit <3> { change_taborder %W 0 }
	bind edit <B1-Motion> { break }
	bind edit <ButtonRelease-1> {}
	bind .gui <1> ""
	global status
	set status(op) "TAB order" 
	no_cut
}

proc bind_cut {} {
	clear_tab_marks
	set_cursor pirate
	bind edit <1> { cut_widget %W %X %Y }
	bind edit <ButtonRelease-1> {}
	bind edit <3> {}
	bind .gui <1> ""
	global status
	set status(op) cut
}

proc bind_copy {} {
	clear_tab_marks
	set_cursor plus
	bind edit <1> { copy_widget %W %X %Y }
	bind edit <ButtonRelease-1> {}
	bind edit <3> {}
	bind .gui <1> ""
	global status
	set status(op) copy
	no_cut
}

bind_select

###############  UTILITY ROUTINES ##########################

# This is a (slightly) improved version of Jeff's vanilla Tk combobox
# (less problems with binding clashes, uses a bitmap on the button, a
# few other features...) but the real effort is his, so I:
#    a) include his original news posting (with as much in the way of
#       headers as my newsreader presents on verbose :^). This also
#       acts as documentation...
#    b) acknowledge that he is the prior author
#
# If you want to use this code commercially, you'll probably need to
# obtain permission from both of us (I imagine that I'd agree without
# any problems, but I can't speak for Jeffrey).
#
# Enjoy!
#
# Donal.  ( mailto:fellowsd@cs.man.ac.uk  -  http://r8h.cs.man.ac.uk:8000/ )

#comp.lang.tcl #32821 (0 + 394 more)
#Path: cs.man.ac.uk!yama.mcc.ac.uk!zippy.dct.ac.uk!btnet!tank.news.pipex.net!
#+     pipex!news.mathworks.com!newsfeed.internetmci.com!chi-news.cic.net!news.
#+     uoregon.edu!cs.uoregon.edu!cs.uoregon.edu!news
#Newsgroups: comp.lang.tcl
#Subject: CODE: Vanilla Tk4 ComboBox
#Message-ID: <46lr31$30t@psychotix.cs.uoregon.edu>
#From: jhobbs@cs.uoregon.edu (Jeffrey Hobbs)
#Date: 25 Oct 1995 10:10:57 -0700
#Organization: University of Oregon Computer and Information Sciences Dept.
#NNTP-Posting-Host: psychotix.cs.uoregon.edu
#Lines: 101
#
#Several people were asking about alternatives to the combobox if they
#didn't have Tix or something.  Since they are so useful, and relatively
#easy to make, I coded some *example* code for a vanilla Tk combobox.
#For the uninitiated, a combobox is just an entry box linked to a popup
#listbox that hold history and such.
#
#This is not a good replacement for Tix's tixComboBox or the incrTk2
#combobox, but is useful starting point for those extensionless users.
#It's mostly an example of an overrideredirected toplevel.
#
#Some notes: double-1 or <Escape> in the entry widget, or selecting the
#button will toggle the listbox portion.  <Escape> will close the listbox
#without a selection.  <Return> in the entry widget adds items (no
#duplicates) to the listbox.  <Tab> in the entry widget searches the listbox
#for a unique match.  <Double-1> in the listbox selects that item.  The
#listbox scrollbar appears when more than 5 items are in the listbox when it
#pops up.  Any args beyond the window name go directly to the entry widget.
#
#Example use:
#pack [combobox .combo]
#pack [combobox .combo -width 20 -textvariable myvar]
#
### BEGIN COMBOBOX CODE ----------8<----------8<-----------8<-----------

set comboboxbuttonimage [image create bitmap -data {#define downbut_width 14
#define downbut_height 14
static char downbut_bits[] = {
   0x00, 0x00, 0xe0, 0x01, 0xe0, 0x01, 0xe0, 0x01, 0xe0, 0x01, 0xfc, 0x0f,
   0xf8, 0x07, 0xf0, 0x03, 0xe0, 0x01, 0xc0, 0x00, 0x00, 0x00, 0xfe, 0x1f,
   0xfe, 0x1f, 0x00, 0x00};
}]

bind ComboEntry <Double-1> {combobox_popup [winfo parent %W]}
bind ComboEntry <Escape>   {combobox_popup [winfo parent %W]}
bind ComboEntry <Tab>      {combobox_find  %W; break}
bind ComboEntry <Return>   {combobox_add   %W}

bind ComboList  <Escape>   {combobox_popup [winfo parent [winfo parent %W]]}
bind ComboList  <Double-1> {combobox_get   %W %y}

proc combobox {w args} {
    global comboboxbuttonimage
    if [winfo exists $w] { error "window $w already exists" }

    frame $w -class ComboBox

    ## Entry Widget, it gets all the args
    eval entry $w.e $args

    ## Button.  With the symbol font, it should be a down arrow
    button $w.b -image $comboboxbuttonimage \
	    -command [list combobox_popup $w]
    pack $w.b -side right -expand 0 -fill both 
    pack $w.e -side left -fill both -expand 1

    ## Removable List Box
    toplevel $w.btm -cursor arrow
    wm withdraw $w.btm
    wm overrideredirect $w.btm 1
    wm transient $w.btm [winfo toplevel $w]
  
    listbox $w.btm.lbox -bd 2 -relief sunken -width 5 -height 5 \
	    -yscrollcommand [list $w.btm.vs set] -selectmode single
    scrollbar $w.btm.vs -width 10 -bd 1 -orient vertical \
		-command [list $w.btm.lbox yview]
    pack $w.btm.lbox -side left -fill both -expand 1

    bindtags $w.e [linsert [bindtags $w.e] 1 ComboEntry]
    bindtags $w.btm.lbox [linsert [bindtags $w.btm.lbox] 1 ComboList]

    return $w
}

proc combobox_setlist {w args} {
    if {[winfo class $w] != "ComboBox"} {
	return -code error "$w not a ComboBox"
    }
    if [winfo ismapped $w.btm] {
	wm withdraw $w.btm
	$w.b configure -relief raised
    }
    $w.btm.lbox delete 0 end
    eval $w.btm.lbox insert end $args
}

proc combobox_getlist w {
    if {[winfo class $w] != "ComboBox"} {
	return -code error "$w not a ComboBox"
    }
    return [$w.btm.lbox get 0 end]
}    

proc combobox_popup w {
    if {[winfo class $w] != "ComboBox"} {
	return -code error "$w not a ComboBox"
    }
    if [winfo ismapped $w.btm] {
	wm withdraw $w.btm
	$w.b configure -relief raised
    } else {
	wm geometry $w.btm [winfo width $w.e]x[winfo reqheight $w.btm]+[winfo rootx $w]+[expr [winfo rooty $w]+[winfo reqheight $w]]
	if {[$w.btm.lbox size] > 5} {
	    pack $w.btm.vs -side right -fill y
	} elseif {[winfo manager $w.btm.vs] == "pack"} {
	    pack forget $w.btm.vs
	}
	wm deiconify $w.btm
	raise $w.btm
	$w.b configure -relief sunken
    }
}

proc combobox_find W {
    set found 0
    set tmp [$W get]
    set lbox [winfo parent $W].btm.lbox
    foreach item [$lbox get 0 end] {
	if ![string first $tmp $item] {
	    incr found
	    set match $item
	}
    }
    switch $found {
	0 {}
	1 {
	    $W delete 0 end
	    $W insert end $match
	}
	default {
	    bell
	}
    }
}
proc combobox_add W {
    set i 1
    set tmp [$W get]
    foreach item [[winfo parent $W].btm.lbox get 0 end] {
	if ![string compare $item $tmp] {
	    set i 0
	    break
	}
    }
    if $i {
	[winfo parent $W].btm.lbox insert end $tmp
    }
    wm withdraw [winfo parent $W].btm
}

proc combobox_get {W y} {
    set e [winfo parent [winfo parent $W]].e
    if [$W size] {
	$e delete 0 end
	$e insert end [$W get [$W nearest $y]]
    }
    wm withdraw [winfo parent $W]
    [winfo parent $e].b configure -relief raised
}

#### END COMBOBOX CODE ------8<------------8<---------8<-------------
#
# Font select dialog by Donal K. Fellows 
# slightly changed for use in TCGUI 

namespace eval dkfFontSel {
    # First some library stuff that is normally in another namespace
    proc parseopts {arglist optlist optarray} {
	upvar $optarray options
	set options(foo) {}
	unset options(foo)
	set callername [lindex [info level -1] 0]
	if {[llength $arglist]&1} {
	    return -code error \
		    "Must be an even number of arguments to $callername"
	}
	array set options $arglist
	foreach key [array names options] {
	    if {![string match -?* $key]} {
		return -code error "All parameter keys must start\
			with \"-\", but \"$key\" doesn't"
	    }
	    if {[lsearch -exact $optlist $key] < 0} {
		return -code error "Bad parameter \"$key\""
	    }
	}
    }

    proc capitalise {word} {
	set cUpper [string toupper [string index $word 0]]
	set cLower [string tolower [string range $word 1 end]]
	return ${cUpper}${cLower}
    }

    proc map {script list} {
	set newlist {}
	foreach item $list {
	    lappend newlist [uplevel 1 $script [list $item]]
	}
	return $newlist
    }

    # ----------------------------------------------------------------------
    # Now we start in earnest
    namespace export chooseFont

    variable Family Helvetica
    variable Size   36
    variable Done   0
    variable Win    {}

    array set Style {
	bold 0
	italic 0
	underline 0
	overstrike 0
    }

    proc make_UI {w} {
	label $w._testing
	set gap [expr {[font metrics [$w._testing cget -font] -linespace]/2+1}]
	destroy $w._testing
	#set gap [winfo pixels $w 2m]

	frame $w.border1 -class DKFChooseFontFrame
	frame $w.border2 -class DKFChooseFontFrame
	frame $w.border3 -class DKFChooseFontFrame
	frame $w.border4 -class DKFChooseFontFrame
	grid $w.border1 -row 0 -column 0 -rowspan 6 -columnspan 4 \
		-padx $gap -pady $gap -sticky nsew
	grid $w.border2 -row 0 -column 4 -rowspan 6 -columnspan 3 \
		-padx $gap -pady $gap -sticky nsew
	grid $w.border3 -row 6 -column 0 -rowspan 3 -columnspan 9 \
		-padx $gap -pady $gap -sticky nsew
	grid $w.border4 -row 9 -column 0 -rowspan 3 -columnspan 9 \
		-padx $gap -pady $gap -sticky nsew
	incr gap $gap
	foreach col {0 3 4 6 8} {
	    grid column $w $col -minsize $gap
	}
	foreach row {0 5 6 8 9 11} {
	    grid row    $w $row -minsize $gap
	}
	foreach col {1 5 7} {
	    grid column $w $col -weight 1
	}
	grid row $w 10 -weight 1

	label $w.lblFamily; label $w.lblStyle
	label $w.lblSize;   label $w.lblSample
	foreach {subname row col} {
	    Family 0 1
	    Style 0 5
	    Size 6 1
	    Sample 9 1
	} {
	    grid $w.lbl$subname -row $row -column $col -sticky w
	}

	frame $w.familyBox
	listbox $w.family -exportsel 0 -selectmode single \
		-xscrollcommand [list $w.familyX set] \
		-yscrollcommand [list $w.familyY set]
	scrollbar $w.familyX -command [list $w.family xview]
	scrollbar $w.familyY -command [list $w.family yview]
	foreach family [listFamilies] {
	    $w.family insert end [map capitalise $family]
	}
	grid $w.familyBox -row 1 -column 1 -rowspan 4 -columnspan 2 \
		-sticky nsew
	grid column $w.familyBox 0 -weight 1
	grid row    $w.familyBox 0 -weight 1
	grid $w.family  $w.familyY -sticky nsew -in $w.familyBox
	grid $w.familyX            -sticky nsew -in $w.familyBox
	bind $w.family <1> [namespace code {
	    set Family [%W get [%W nearest %y]]
	    setfont
	}]

	foreach {fontstyle lcstyle row} {
	    Bold bold 1
	    Italic italic 2
	    Underline underline 3
	    Strikeout overstrike 4
	} {
	    set b $w.style$fontstyle
	    checkbutton $b -variable [namespace current]::Style($lcstyle) \
		    -command [namespace code setfont]
	    grid $b -row $row -column 5 -sticky nsew
	}

	frame $w.size
	grid $w.size -row 7 -column 1 -rowspan 1 -columnspan 7 -sticky nsew
	foreach {size row col} {
	    10 0 0
	    14 1 0
	    18 0 1
	    24 1 1
	    36 0 2
	    48 1 2
		72 0 3
		96 1 3
	} {
	    set b $w.size.b$size
	    radiobutton $b -variable [namespace current]::Size -value $size \
		    -command [namespace code setfont]
	    grid $b -row $row -column $col -sticky ew
	    #grid column $w.size $col -weight 1
	}
	entry $w.size.entry -textvariable [namespace current]::Size
	grid $w.size.entry -row 0 -column 4 -rowspan 2 -sticky ew
	grid column $w.size 3 -weight 1
	bind $w.size.entry <Return> \
		[namespace code {setfont;break}]

	frame $w.sample
	grid $w.sample -row 10 -column 1 -columnspan 7 -sticky nsew
	grid propagate $w.sample 0
	label $w.sample.text
	grid $w.sample.text

	frame $w.butnframe
	grid $w.butnframe -row 0 -column 7 -rowspan 6 -columnspan 2 \
		-sticky nsew -pady $gap
	foreach {but code} {
	    ok  0
	    can 1
	} {
	    button $w.butnframe.$but -command \
		    [namespace code [list set Done $code]]
	    pack $w.butnframe.$but -side top -fill x -padx [expr {$gap/2}]
	}
	grid row $w 1 -weight 1
    }

    proc setfont {} {
	variable Family
	variable Style
	variable Size
	variable Win

	set styles {}
	foreach style {italic bold underline overstrike} {
	    if {$Style($style)} {
		lappend styles $style
	    }
	}
	if {[catch {
	    expr {$Size+0}
	    if {[llength $styles]} {
		$Win configure -font [list $Family $Size $styles]
	    } else {
		$Win configure -font [list $Family $Size]
	    }
	} s]} {
	    bgerror $s
	    return 1
	}
	return 0
    }

    proc listFamilies {} {
	return [lsort [string tolower [font families]]]
    }

    # ----------------------------------------------------------------------

    proc chooseFont {args} {
	variable Family
	variable Style
	variable Size
	variable Done
	variable Win

	array set options {
	    -parent {}
	    -title {Select a font}
	    -initialfont {Courier 18 bold}
	}
	parseopts $args {-parent -title -initialfont} options
	switch -exact -- $options(-parent) {
	    . - {} {
		set parent .
		set w .__dkf_chooseFont
	    }
	    default {
		set parent $options(-parent)
		set w $options(-parent).__dkf_chooseFont
	    }
	}
	catch {destroy $w}

	toplevel $w -class DKFChooseFont
	wm title $w $options(-title)
	wm transient $w $parent
	wm iconname $w ChooseFont
	wm group $w $parent
	wm protocol $w WM_DELETE_WINDOW {#}

	set Win $w.sample.text
	make_UI $w
	bind $w <Return>  [namespace code {set Done 0}]
	bind $w <Escape>  [namespace code {set Done 1}]
	bind $w <Destroy> [namespace code {set Done 1}]
	focus $w.butnframe.ok

	foreach style {italic bold underline overstrike} {
	    set Style($style) 0
	}
	foreach {family size styles} $options(-initialfont) {break}
	set Family $family
	set familyIndex [lsearch -exact [listFamilies] \
		[string tolower $family]]
	if {$familyIndex<0} {
	    return -code error "unknown font family \"$family\""
	}
	$w.family selection set $familyIndex
	$w.family see $familyIndex
	set Size $size
	foreach style $styles {set Style($style) 1}

	setfont

	wm withdraw $w
	update idletasks
	if {$options(-parent)==""} {
	    set x [expr {([winfo screenwidth $w]-[winfo reqwidth $w])/2}]
	    set y [expr {([winfo screenheigh $w]-[winfo reqheigh $w])/2}]
	} else {
	    set pw $options(-parent)
	    set x [expr {[winfo x $pw]+
                         ([winfo width $pw]-[winfo reqwidth $w])/2}]
	    set y [expr {[winfo y $pw]+
                         ([winfo heigh $pw]-[winfo reqheigh $w])/2}]
	}
	wm geometry $w +$x+$y
	update idletasks
	wm deiconify $w
	tkwait visibility $w
	vwait [namespace current]::Done
	if {$Done} {
	    destroy $w
	    return ""
	}
	if {[setfont]} {
	    destroy $w
	    return ""
	}
	set font [$Win cget -font]
	destroy $w
	return $font
    }

    # ----------------------------------------------------------------------
    # I normally load these from a file, but I inline them here for portability
    foreach {pattern value} {
	*DKFChooseFont*Button.BorderWidth      1
	*DKFChooseFont*Checkbutton.BorderWidth 1
	*DKFChooseFont*Entry.BorderWidth       1
	*DKFChooseFont*Label.BorderWidth       1
	*DKFChooseFont*Listbox.BorderWidth     1
	*DKFChooseFont*Menu.BorderWidth        1
	*DKFChooseFont*Menubutton.BorderWidth  1
	*DKFChooseFont*Message.BorderWidth     1
	*DKFChooseFont*Radiobutton.BorderWidth 1
	*DKFChooseFont*Scale.BorderWidth       1
	*DKFChooseFont*Scrollbar.BorderWidth   1
	*DKFChooseFont*Text.BorderWidth        1
	*DKFChooseFont.DKFChooseFontFrame.borderWidth 2
	*DKFChooseFont.DKFChooseFontFrame.relief      ridge
	*DKFChooseFont.lblFamily.text 	       Family
	*DKFChooseFont.lblStyle.text  	       Style
	*DKFChooseFont.lblSize.text   	       Size
	*DKFChooseFont.lblSample.text 	       Sample
	*DKFChooseFont.Label.padX              1m
	*DKFChooseFont.Label.padY              1
	*DKFChooseFont.Radiobutton.anchor      w
	*DKFChooseFont.Checkbutton.anchor      w
	*DKFChooseFont.family.height           1
	*DKFChooseFont.family.width            12
	*DKFChooseFont.familyX.orient 	       horizontal
	*DKFChooseFont.familyX.width  	       10
	*DKFChooseFont.familyY.width  	       10
	*DKFChooseFont.styleBold.text 	       Bold
	*DKFChooseFont.styleItalic.text        Italic
	*DKFChooseFont.styleUnderline.text     Underline
	*DKFChooseFont.styleStrikeout.text     Overstrike
	*DKFChooseFont.size.b10.text           10
	*DKFChooseFont.size.b14.text           14
	*DKFChooseFont.size.b18.text           18
	*DKFChooseFont.size.b24.text           24
	*DKFChooseFont.size.b36.text           36
	*DKFChooseFont.size.b48.text           48
	*DKFChooseFont.size.b72.text           72
	*DKFChooseFont.size.b96.text           96
	*DKFChooseFont.size.Radiobutton.anchor w
	*DKFChooseFont.size.Entry.background   white
	*DKFChooseFont.sample.text.text	       ABCabcXYZxyz123
	*DKFChooseFont.sample.height           120
	*DKFChooseFont.sample.width            40
	*DKFChooseFont.butnframe.ok.default    active
	*DKFChooseFont.butnframe.ok.text       OK
	*DKFChooseFont.butnframe.can.text      Cancel
    } {
	option add $pattern $value startupFile
    }
}
namespace import dkfFontSel::chooseFont

# base64.tcl --
#
# Encode/Decode base64 for a string
# Stephen Uhler / Brent Welch (c) 1997 Sun Microsystems
# The decoder was done for exmh by Chris Garrigues
#
# Copyright (c) 1998-2000 by Ajuba Solutions.
# See the file "license.terms" for information on usage and redistribution
# of this file, and for a DISCLAIMER OF ALL WARRANTIES.
# 
# RCS: @(#) $Id: base64.tcl,v 1.8 2000/10/11 20:04:11 welch Exp $

# Version 1.0 implemented Base64_Encode, Bae64_Decode
# Version 2.0 uses the base64 namespace
# Version 2.1 fixes various decode bugs and adds options to encode

namespace eval base64 {
    variable i 0
    variable char
    variable base64
    variable base64_en
    foreach char {A B C D E F G H I J K L M N O P Q R S T U V W X Y Z \
	      a b c d e f g h i j k l m n o p q r s t u v w x y z \
	      0 1 2 3 4 5 6 7 8 9 + /} {
	set base64($char) $i
	set base64_en($i) $char
	incr i
    }

    namespace export *
}
# base64::encode --
#
#	Base64 encode a given string.
#
# Arguments:
#	args	?-maxlen maxlen? ?-wrapchar wrapchar? string
#	
#		If maxlen is 0, the output is not wrapped.
#
# Results:
#	A Base64 encoded version of $string, wrapped at $maxlen characters
#	by $wrapchar.

proc base64::encode {args} {
    variable base64_en
    
    # Set the default wrapchar and maximum line length to match the output
    # of GNU uuencode 4.2.  Various RFC's allow for different wrapping 
    # characters and wraplengths, so these may be overridden by command line
    # options.
    set wrapchar "\n"
    set maxlen 60

    if { [llength $args] == 0 } {
	error "wrong # args: should be \"[lindex [info level 0] 0]\
		?-maxlen maxlen? ?-wrapchar wrapchar? string\""
    }

    set optionStrings [list "-maxlen" "-wrapchar"]
    for {set i 0} {$i < [llength $args] - 1} {incr i} {
	set arg [lindex $args $i]
	set index [lsearch -glob $optionStrings "${arg}*"]
	if { $index == -1 } {
	    error "unknown option \"$arg\": must be -maxlen or -wrapchar"
	}
	incr i
	if { $i >= [llength $args] - 1 } {
	    error "value for \"$arg\" missing"
	}
	set val [lindex $args $i]
	set [string range [lindex $optionStrings $index] 1 end] $val
    }
    
    if { ![string is integer -strict $maxlen] } {
	error "expected integer but got \"$maxlen\""
    }

    set string [lindex $args end]

    set result {}
    set state 0
    set length 0
    foreach {c} [split $string {}] {
	# Do the line length check before appending so that we don't get an
	# extra newline if the output is a multiple of $maxlen chars long.
	if {$maxlen && $length >= $maxlen} {
	    append result $wrapchar
	    set length 0
	}
	scan $c %c x
	switch [incr state] {
	    1 {	append result $base64_en([expr {($x >>2) & 0x3F}]) }
	    2 { append result \
		$base64_en([expr {(($old << 4) & 0x30) | (($x >> 4) & 0xF)}]) }
	    3 { append result \
		$base64_en([expr {(($old << 2) & 0x3C) | (($x >> 6) & 0x3)}])
		append result $base64_en([expr {($x & 0x3F)}])
		incr length
		set state 0}
	}
	set old $x
	incr length
    }
    set x 0
    switch $state {
	0 { # OK }
	1 { append result $base64_en([expr {(($old << 4) & 0x30)}])== }
	2 { append result $base64_en([expr {(($old << 2) & 0x3C)}])=  }
    }
    return $result
}

#
# base64::decode --
#
#	Base64 decode a given string.
#
# Arguments:
#	string	The string to decode.  Characters not in the base64
#		alphabet are ignored (e.g., newlines)
#
# Results:
#	The decoded value.

proc base64::decode {string} {
    variable base64

    set output {}
    set group 0
    set j 18
    foreach char [split $string {}] {
	if {[string compare $char "="]} {
	    # RFC 2045 says that line breaks and other characters not part
	    # of the Base64 alphabet must be ignored, and that the decoder
	    # can optionally emit a warning or reject the message.  We opt
	    # not to do so, but to just ignore the character.

	    if { ![info exists base64($char)] } {
		continue
	    }
	    set bits $base64($char)
	    set group [expr {$group | ($bits << $j)}]
	    if {[incr j -6] < 0} {
		scan [format %06x $group] %2x%2x%2x a b c
		append output [format %c%c%c $a $b $c]
		set group 0
		set j 18
	    }
	} else {
	    # = indicates end of data.  Output whatever chars are left.
	    # The encoding algorithm dictates that we can only have 1 or 2
	    # padding characters.  If j is 6, we have 12 bits of input 
	    # (enough for 1 8-bit output).  If j is 0, we have 18 bits of
	    # input (enough for 2 8-bit outputs).
	    # It is crucial to scan three hex digits even though we
	    # discard c - older code used %04x and scanned 2 hex digits
	    # but really ended up generating 5 or 6 (not 4!) digits and
	    # resulted in alignment errors.

	    scan [format %06x $group] %2x%2x%2x a b c
	    if {$j == 6} {
		append output [format %c $a]
	    } elseif {$j == 0} {
		append output [format %c%c $a $b]
	    }
	    break
	}
    }
    return $output
}

#package provide base64 2.1

namespace import base64::*

proc compare {s1 s2} {
    if {[string equal $s1 $s2]} {
	return equal
    }
    if {[string length $s1] != [string length $s2]} {
	return "s1 length [string length $s1] != s2 length [string length $s2]"
    }
    set i 0
    foreach c1 [split $s1 {}] c2 [split $s2 {}] {
	if {[string compare $c1 $c2] != 0} {
	    scan $c1 %c c1scanval
	    scan $c2 %c c2scanval
	    binary scan $c1 a c1binval
	    binary scan $c2 a c2binval
	    return "char($i) c1 $c1 $c1scanval $c1binval c2 $c2 $c2scanval $c2binval"
	}
	incr i
    }
}

############ ENCODING AND FILE MANIPULATION  ##############
proc set_mainwin {appl mw mh} {
	global tcgui
	set tcgui(name) $appl
	.gui config -width $mw -height $mh
}

proc set_coboffset {} {
	global tcgui
	set ofs 0
	set radios {}
	set offsets {}
	foreach w $tcgui(widgets) {
		set w $w.w
		if {[info exists tcgui(value,$w,cobolvar)] &&
			$tcgui(value,$w,cobolvar) != "" &&
			[info exists tcgui(value,$w,cobsize)] &&
			$tcgui(value,$w,cobsize) != ""} {
				set tcgui(coboffset,$w) $ofs
				if {[winfo class $w] != "Radiobutton"} {
					incr ofs $tcgui(value,$w,cobsize)
				} elseif {[lsearch $radios $tcgui(value,$w,cobolvar)] < 0} {
					lappend radios $tcgui(value,$w,cobolvar)
					lappend offsets $ofs
					incr ofs
				} else {
					set n [lsearch $radios $tcgui(value,$w,cobolvar)]
					set tcgui(coboffset,$w) [lindex $offsets $n]
				}
		}
	}
}

proc file_new {} {
	global tcgui
	foreach w $tcgui(widgets) {
		#if {$tcgui(parent,$w) == ".gui"} 
		if {$tcgui(parent,$w) == "."} {
			destroy $w
		}
	}
	array unset tcgui value,*
	clear_tab_marks
	init_tcgui
	bind_select
}

proc set_taborder {args} {
	global tcgui
	set new {}
	foreach n $args {
		lappend new [lindex $tcgui(taborder) \
			[lsearch -glob $tcgui(taborder) *$n*]]
	}
	set tcgui(taborder) $new
}

proc next_taborder {{w {}}} {
	global tcgui
	if {$w == {}} {
		focus [lindex $tcgui(taborder) 0]
	}
	set n [lsearch $tcgui(taborder) $w]
	if {$n >= 0} {
		incr n
	} else {
		set n 0
	}
	if {$n < [llength $tcgui(taborder)]} {
		focus [lindex $tcgui(taborder) $n]
	} else {
		focus [lindex $tcgui(taborder) 0]
	}
}

proc change_taborder {w ins} {
	global tcgui
	set n [lsearch $tcgui(taborder) $w]
	if {$n >= 0} {
		set tcgui(taborder) [lreplace $tcgui(taborder) $n $n]
		if {"$ins" == "end"} {
			lappend tcgui(taborder) $w
		} else {
			set tcgui(taborder) [linsert $tcgui(taborder) 0 $w]
		}
	}
	focus $w
	clear_tab_marks
	draw_tab_marks
	return -code break
}

proc _taborder {} {
	global tcgui
	set r {}
	foreach w $tcgui(taborder) {
		set ww $tcgui(container,$w)
		if {[info exists tcgui(value,$ww,widgetname)] &&
			$tcgui(value,$ww,widgetname) != ""} {
			set wname $tcgui(value,$ww,widgetname)
		} else {
			set wname [lindex [split $ww .] end]
		}
		lappend r $wname 
	}
	return $r
}

proc menu_desc {m mi parentname} {
	global tcgui
	set ats {}
	foreach at $tcgui(attrib,Menuitem) {
		if {[info exists tcgui(value,$m,$mi,$at)] &&
			$tcgui(value,$m,$mi,$at) != ""} {
				if {[$m type $mi] != "separator"} {
					lappend ats $at $tcgui(value,$m,$mi,$at)
				} else {
					set ats [list separator 1]
				}
		}
	}
	set parent .[join [lrange [split $m .] 2 end] .]
	set widgetdesc "cMenuitem $parentname/$mi $parent 0 0"
	append widgetdesc " 0 0 \{\} \{\} \{\} $ats"
	return $widgetdesc
}

proc out_menu_desc {f m level {parentname {}}} {
	if {$level == 0} {
		set parentname [lindex [split $m .] end-2]
	}
	for {set mi 0} {$mi < [$m index end]} {incr mi} {
		puts $f [menu_desc $m $mi $parentname]
		if {[$m type $mi] == "cascade"} {
			out_menu_desc $f $m.$mi [expr $level+1] $parentname/$mi
		}
	}
}

proc out_menu_events {f m level start_ev {parentname {}}} {
	global tcgui
	upvar 1 $start_ev usr_ev
	#puts "out_menu_events: $m $level $usr_ev $parentname"
	if {$level == 0} {
		set parentname [lindex [split $m .] end-2]
	}
	for {set mi 0} {$mi < [$m index end]} {incr mi} {
		if {[$m type $mi] == "command"} {
			if {[info exists tcgui(value,$m,$mi,eventname)]} {
				set evname $tcgui(value,$m,$mi,eventname)
				puts $f "     88  $tcgui(name)-EV-$evname VALUE [incr usr_ev]."
			}
		} elseif {[$m type $mi] == "cascade"} {
			out_menu_events $f $m.$mi [expr $level+1] usr_ev $parentname
		}
	}
}

proc widget_desc {w} {
	global tcgui
	set parent $tcgui(parent,$w)
	set cmd $tcgui(ccmd,[winfo class $w.w])
	set name [lindex [split $w .] end]
	array set p [place info $w]
	set width [lindex [$w config -width] 4]
	set height [lindex [$w config -height] 4]
	set ats {}
	set ww $w.w
	foreach at $tcgui(attrib,[winfo class $ww]) {
		if {[info exists tcgui(value,$ww,$at)] &&
			$tcgui(value,$ww,$at) != "" &&
			[lsearch {cobolvar cobsize coboffset} $at] < 0 } {
				lappend ats $at $tcgui(value,$ww,$at)
		}
	}
	set cobolvar "\{\}"
	set cobsize 1
	set coboffset 0
	if {[info exists tcgui(value,$ww,cobolvar)] &&
		$tcgui(value,$ww,cobolvar) != ""} {
			set cobolvar $tcgui(value,$ww,cobolvar)
		if {[info exists tcgui(value,$ww,cobsize)] &&
			$tcgui(value,$ww,cobsize) != ""} {
				set cobsize $tcgui(value,$ww,cobsize)
		}
		if {[info exists tcgui(coboffset,$ww)] &&
			$tcgui(coboffset,$ww) != ""} {
				set coboffset $tcgui(coboffset,$ww)
		}
	}
	set widgetdesc "$cmd $name $parent $p(-x) $p(-y)"
	append widgetdesc " $width $height $cobolvar $cobsize $coboffset $ats"
	return $widgetdesc
}

proc file_save {} {
	global tcgui
	set types { {{design files} {.gui}} {{All files} {*}} }
	set initdir ""
	if {[info exists tcgui(initialdir)]} {
		set initdir "-initialdir $tcgui(initialdir)"
	}
	set initfile ""
	if {[info exists tcgui(initialfile)]} {
		set initdir "-initialfile $tcgui(initialfile)"
	}
	set fn [eval tk_getSaveFile -defaultextension .gui -filetypes \$types \
		$initdir $initfile]
	if {$fn == ""} {
		return ""
	}
	set tcgui(initialdir) [file dirname $fn]
	set tcgui(initialfile) [file tail $fn]
	
	set_coboffset
	set f [open $fn w]
	set mw [winfo width .gui] 
	set mh [winfo height .gui]
	puts $f "set_mainwin $tcgui(name) $mw $mh"
	# output all except menus
	foreach w $tcgui(widgets) {
		if {[winfo class $w.w] == "Menubutton"} {
			continue
		}
		puts $f [widget_desc $w] 
	}
	# output now all menus
	foreach w $tcgui(widgets) {
		if {[winfo class $w.w] != "Menubutton"} {
			continue
		}
		puts $f [widget_desc $w] 
		out_menu_desc $f $w.w.m 0
	}
	puts $f "set_taborder [_taborder]"
	close $f
	return $fn
}

proc file_load {} {
	global tcgui
	set types { {{design files} {.gui}} {{All files} {*}} }
	set initdir ""
	if {[info exists tcgui(initialdir)]} {
		set initdir "-initialdir $tcgui(initialdir)"
	}
	set initfile ""
	if {[info exists tcgui(initialfile)]} {
		set initdir "-initialfile $tcgui(initialfile)"
	}
	set fn [eval tk_getOpenFile -filetypes \$types \
		$initdir $initfile]
	if {$fn == ""} {
		return ""
	}
	set tcgui(initialdir) [file dirname $fn]
	set tcgui(initialfile) [file tail $fn]
	
	file_new
	source $fn
	set i 0
	foreach w $tcgui(widgets) {
		set name [lindex [split $w .] end]
		catch {set i [expr [string trimleft $name 0]+1]}
		if {$i > $tcgui(autoname)} {
			set tcgui(autoname) $i
		}
	}
	next_taborder
}

proc puts_cmds {f} {
	global tcgui
	foreach {ix val} [array get tcgui cmds,*] {
		set n [lindex [split $ix ,] end]
		puts $f "     88  $tcgui(name)-CMD-$n VALUE $val."
	}
}

proc puts_events {f} {
	global tcgui
	foreach {ix val}  [array get tcgui events,*] {
		set n [lindex [split $ix ,] end]
		puts $f "     88  $tcgui(name)-SYSEV-$n VALUE $val."
	}
	# generate user button and timer events (1-10 system events, reserved)
	set usr_ev 10
	foreach w $tcgui(widgets) {
	    if {[info exists tcgui(value,$w.w,eventname)]} {
			set evname $tcgui(value,$w.w,eventname)
			puts $f "     88  $tcgui(name)-EV-$evname VALUE [incr usr_ev]."
		}
	}
	# generate menu events
	foreach w $tcgui(widgets) {
		if {[winfo class $w.w] == "Menubutton"} {
			out_menu_events $f $w.w.m 0 usr_ev
		}
	}
}

proc puts_attrs {f} {
	global tcgui
	foreach {ix val} [array get tcgui attrs,*] {
		set n [lindex [split $ix ,] end]
		puts $f "     88  $tcgui(name)-ATTR-$n VALUE $val."
	}
}

proc puts_widgets {f} {
	global tcgui
	foreach w $tcgui(widgets) {
		set n [lindex [split $w ,] end]
		set n1 [lindex [split $n .] end]
		set wname $n1
		if {[info exists tcgui(value,$w.w,widgetname)] &&
			$tcgui(value,$w.w,widgetname) != ""} {
			 set wname $tcgui(value,$w.w,widgetname)
		}	
		puts $f \
		"     88  $tcgui(name)-WIDGET-$wname VALUE [string trimleft $n1 0]."
	}
}

proc puts_cobolvars {f} {
	global tcgui
	set varlist {}
	set size 0
	foreach w $tcgui(widgets) {
		set w $w.w
		if {[info exists tcgui(value,$w,cobolvar)] &&
			$tcgui(value,$w,cobolvar) != ""} {
				set v $tcgui(value,$w,cobolvar)
				if {[lsearch $varlist $v] < 0} {
					lappend varlist $v
					if {[winfo class $w] == "Radiobutton"} {
						incr size
					}
				}
				set vsize($v) 0
				if {[winfo class $w] == "Radiobutton"} {
					set vsize($v) 1
					lappend vlist($v) $w
				} elseif {[winfo class $w] == "Checkbutton"} {
					set vsize($v) 1
					incr size $vsize($v)
				} else {
					set vsize($v) $tcgui(value,$w,cobsize)
					incr size $vsize($v)
				}
				set vw($v) $w
		}
	}
#
	puts $f "   05    $tcgui(name)-COBOL-VARS-SIZE PIC 9(9) COMP VALUE $size."
	if {$size} {
		puts $f "   05    $tcgui(name)-COBOL-VARIABLES."
	}
	foreach v $varlist {
		if {[winfo class $vw($v)] == "Radiobutton"} {
			puts $f "     10  $v PIC X."
			foreach vl $vlist($v) {
				set n1 [lindex [split $vl .] end-1]
				set wname $n1
				if {[info exists tcgui(value,$vl,widgetname)] &&
						$tcgui(value,$vl,widgetname) != ""} {
						set wname $tcgui(value,$vl,widgetname)
				}	
				set selval $tcgui(value,$vl,selval)
				puts $f "       88  $wname VALUE \"$selval\"."
			}
		} elseif {[winfo class $vw($v)] == "Checkbutton"} {
				puts $f "     10  $v PIC 9."
				puts $f "       88  $v-ON VALUE 1."
				puts $f "       88  $v-OFF VALUE 0."
		} else {
			puts $f "     10  $v PIC X($vsize($v))."
		}
	}
}

proc generate_cpy {} {
	global tcgui comments
#	set fn [tk_getSaveFile -defaultextension cpy -title "Copybook to generate"]
	set fn [file_save]
# compress with gzip
	catch {file delete tmp.tcl.gz}
	exec gzip -c [file rootname $fn].gui > tmp.tcl.gz

# encode file (base64)
	set f [open tmp.tcl.gz r]
	fconfigure $f -encoding binary -translation binary
	set s [read $f]
	close $f
	file delete tmp.tcl.gz

# save copybook
	set f [open [file rootname $fn].cpy w]
	puts $f [subst $comments(1)]
	puts $f " 01      $tcgui(name)-GUI."
	puts $f "   05    $tcgui(name)-GUI-COMMAND PIC 9(9) COMP."
	puts_cmds $f
	puts $f "   05    $tcgui(name)-GUI-EVENT PIC 9(9) COMP."
	puts_events $f
	puts $f "   05    $tcgui(name)-GUI-NAME PIC X(40) VALUE \"$tcgui(name)\"."
	puts $f "   05    $tcgui(name)-ATTRIB-TYPE PIC 9(9) COMP."
	puts_attrs $f
	puts $f "   05    $tcgui(name)-ATTRIB-VALUE PIC X(80)."
	puts $f "   05    $tcgui(name)-WIDGET-SELECT PIC 9(9) COMP."
	puts_widgets $f
	puts_cobolvars $f
	puts $f "   05    $tcgui(name)-GUI-LOADED PIC 9(9) COMP VALUE 0."
	puts $f "   05    $tcgui(name)-GUI-CODE."
	foreach line [split [encode $s] \n] {
		puts $f "    10   FILLER PIC X(60) VALUE\n         \"$line\"."
	}
	close $f
}

