 IDENTIFICATION DIVISION.
 PROGRAM-ID.    testgui01.  
 AUTHOR. Rildo Pragana.         
* REMARKS.
*    Example tcl/tk GUI program for Cobol.
*
 ENVIRONMENT DIVISION.
 CONFIGURATION SECTION.
 INPUT-OUTPUT SECTION.
 FILE-CONTROL.
    SELECT SALES-FILE
         ASSIGN TO "sales.dat"
         ORGANIZATION IS LINE SEQUENTIAL 
         ACCESS MODE  IS SEQUENTIAL.

 DATA DIVISION.
 FILE SECTION.
    FD SALES-FILE.
    01        sales-record.
     05       sales-data-1.
  	   15     sales-vendor-name      pic X(20).
       15     sales-value            pic S9(6).
       15     sales-number           pic X(13).
       15     sales-type             pic X.
       15     sales-vendor-region    pic X(17).
       15     sales-vendor-city      pic X(20).
     05     sales-comments         pic X(60).
*
 WORKING-STORAGE SECTION.
    copy design1.
    copy design2.
    copy design3.
 77 FLAG-END	PIC X.

 PROCEDURE DIVISION.
  MOVE SPACES TO EXAMPLE-COBOL-VARIABLES GUI2-COBOL-VARIABLES
  	GUI3-COBOL-VARIABLES
 
  OPEN INPUT SALES-FILE
  MOVE 'N' TO FLAG-END.
  PERFORM 400-POPULATE-LISTBOX-GUI3
     UNTIL FLAG-END = 'Y'.
  CLOSE SALES-FILE.

  PERFORM 300-POPULATE-COMBOBOX-EXAMPLE
  
  SET GUI2-CMD-WITHDRAW TO TRUE
  CALL "TCGUI" USING GUI2-GUI. 
*  SET EXAMPLE-CMD-WITHDRAW TO TRUE
*  CALL "TCGUI" USING EXAMPLE-GUI. 
  SET EXAMPLE-CMD-DISPLAY TO TRUE
  CALL "TCGUI" USING EXAMPLE-GUI. 
  
  PERFORM UNTIL GUI3-EV-EXIT OR EXAMPLE-EV-EXIT
	  SET GUI3-CMD-WAIT TO TRUE
	  CALL "TCGUI" USING GUI3-GUI 
 	  DISPLAY "GUI3 VARIABLES """ GUI3-COBOL-VARIABLES """"
 	  DISPLAY "EXAMPLE VARIABLES """ EXAMPLE-COBOL-VARIABLES """"
  END-PERFORM.
     
  SET GUI3-CMD-WITHDRAW TO TRUE
  CALL "TCGUI" USING GUI3-GUI. 
 
  MOVE "This is an example of message (text) widget, that wraps messages longer that cannot fit a single line." TO LMSG
  SET RADIO-B TO TRUE
  SET CHECK-A-ON TO TRUE
  SET GUI2-CMD-DISPLAY TO TRUE
  CALL "TCGUI" USING GUI2-GUI. 
  PERFORM 500-LOOP-WAIT
	 UNTIL GUI2-EV-END.
 
  SET GUI2-CMD-WITHDRAW TO TRUE
  CALL "TCGUI" USING GUI2-GUI. 
  
  MOVE "Your name here" to NAME
  SET EXAMPLE-CMD-DISPLAY TO TRUE
  CALL "TCGUI" USING EXAMPLE-GUI. 

  MOVE 'N' TO FLAG-END.
  PERFORM 200-GET-DATA 
  	UNTIL FLAG-END = 'Y'.
  SET EXAMPLE-CMD-WITHDRAW TO TRUE
  CALL "TCGUI" USING EXAMPLE-GUI. 
  
  SET GUI2-CMD-SET-ATTR TO TRUE
  SET GUI2-ATTR-BACKGROUND TO TRUE
  SET GUI2-WIDGET-SETUP TO TRUE
  MOVE "pink" to GUI2-ATTRIB-VALUE
  CALL "TCGUI" USING GUI2-GUI. 
  
  SET GUI2-CMD-SET-ATTR TO TRUE
  SET GUI2-ATTR-BACKGROUND TO TRUE
  SET GUI2-WIDGET-LMSG TO TRUE
  MOVE "navy" to GUI2-ATTRIB-VALUE
  CALL "TCGUI" USING GUI2-GUI. 
  
  SET GUI2-CMD-SET-ATTR TO TRUE
  SET GUI2-ATTR-FOREGROUND TO TRUE
  SET GUI2-WIDGET-LMSG TO TRUE
  MOVE "white" to GUI2-ATTRIB-VALUE
  CALL "TCGUI" USING GUI2-GUI. 
  
  MOVE "Observe we have changed the BACKGROUND attribute of the button labelled ""setup"" at the right." TO LMSG
  SET RADIO-B TO TRUE
  SET CHECK-A-ON TO TRUE
  SET GUI2-CMD-DISPLAY TO TRUE
  CALL "TCGUI" USING GUI2-GUI. 
  
  SET GUI2-CMD-WAIT TO TRUE
  CALL "TCGUI" USING GUI2-GUI. 
  DISPLAY GUI2-COBOL-VARIABLES
  
  STOP RUN.

***************************************************************
  100-SHOW-EVENT.
  DISPLAY "EVENT: (" EXAMPLE-GUI-EVENT ") " NO ADVANCING.
  EVALUATE TRUE
    WHEN EXAMPLE-EV-ENTER
  		DISPLAY "EXAMPLE-EV-ENTER"
  	WHEN EXAMPLE-EV-EXIT
  		DISPLAY "EXAMPLE-EV-EXIT"
  	WHEN EXAMPLE-EV-EV-A
  		DISPLAY "EXAMPLE-EV-EV-A"
*  	WHEN EXAMPLE-EV-EV-B
*  		DISPLAY "EXAMPLE-EV-EV-B"
  	WHEN EXAMPLE-EV-EV-C
  		DISPLAY "EXAMPLE-EV-EV-C"
  	WHEN OTHER 
  		DISPLAY "*** UNKNOWN EVENT ***"
  END-EVALUATE.

  200-GET-DATA.
  SET EXAMPLE-CMD-WAIT TO TRUE
  CALL "TCGUI" USING EXAMPLE-GUI. 
  PERFORM 100-SHOW-EVENT
  IF EXAMPLE-EV-EXIT
		MOVE 'Y' TO FLAG-END. 
  DISPLAY "Returned data:".
  DISPLAY "NAME    [" NAME "]".
  DISPLAY "MSG     [" MSG "]".
  DISPLAY "-----------------------------------------". 
  
  300-POPULATE-COMBOBOX-EXAMPLE.
  SET EXAMPLE-CMD-INSERT-VALUE TO TRUE
  SET EXAMPLE-WIDGET-ENT-MSG TO TRUE
  MOVE "Alagoas" TO MSG
  CALL "TCGUI" USING EXAMPLE-GUI. 
  MOVE "Pernambuco" TO MSG
  CALL "TCGUI" USING EXAMPLE-GUI. 
  SET EXAMPLE-CMD-SELECT-VALUE TO TRUE
  CALL "TCGUI" USING EXAMPLE-GUI. 
  SET EXAMPLE-CMD-INSERT-VALUE TO TRUE
  MOVE "Paraiba" TO MSG
  CALL "TCGUI" USING EXAMPLE-GUI. 
  MOVE "Rio Grande do Norte" TO MSG
  CALL "TCGUI" USING EXAMPLE-GUI. 
  MOVE "Bahia" TO MSG
  CALL "TCGUI" USING EXAMPLE-GUI. 
  MOVE "Sergipe" TO MSG
  CALL "TCGUI" USING EXAMPLE-GUI. 
  
  400-POPULATE-LISTBOX-GUI3.
  SET GUI3-CMD-INSERT-VALUE TO TRUE
  SET GUI3-WIDGET-ITEM-LIST TO TRUE
  READ SALES-FILE 
  	AT END MOVE 'Y' TO FLAG-END.
  MOVE SALES-RECORD TO ITEMS
  CALL "TCGUI" USING GUI3-GUI. 
  
  500-LOOP-WAIT.
  MOVE SPACES TO GUI2-COBOL-VARIABLES
  SET GUI2-CMD-WAIT TO TRUE
  CALL "TCGUI" USING GUI2-GUI. 
  DISPLAY "EVENT: (" GUI2-GUI-EVENT ") --> " NO ADVANCING.
  EVALUATE TRUE
     WHEN GUI2-EV-SETUP
     	DISPLAY "GUI2-EV-SETUP"
     WHEN GUI2-EV-END
     	DISPLAY "GUI2-EV-END"
  END-EVALUATE.
  DISPLAY "GUI2COBOL-VARIABLES """ GUI2-COBOL-VARIABLES """".
  
